#include <allegro.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#define BACKGROUND_WIDTH 1024
#define BACKGROUND_HEIGHT 1024
#define MISSILE_SPEED 4
#define SHIP_GRAPHIC_COUNT 9
#define MAX_FRAME_COUNT 8
#define MAX_SHIP_COUNT 32
#define MAX_BULLET_COUNT 32
#define DISPLAY_WIDTH 512
#define DISPLAY_HEIGHT 512
#define SCREEN_WIDTH 1024
#define SCREEN_HEIGHT 768
#define SHIP_TO_SHIP_THRESHOLD 32
#define BULLET_TO_SHIP_THRESHOLD 18
#define BULLET_SPEED 6
#define RELOAD_RATE 28
#define MINI_SHOT 6
#define DIVE_LENGTH 128
#define BORDER 400
#define FLIGHT_PATTERN_COUNT 22
#define MAX_CT 256
#define QUARTER_CT 64
#define LEVEL_COUNT 7
#define LEVEL_GRAPHIC_COUNT 4
#define NUMBER_HEIGHT 32
#define NUMBER_WIDTH 19
#define REPAIR_TIME 128*2
#define LEVEL_CHANGE 50
#define POINTS_FOR_MISSILE_CHUCKER 50
#define POINTS_FOR_HARD_SHOOTER 25
#define POINTS_FOR_SHOOTER 10
#define SLOMO_LENGTH 128*4
#define LEVEL_CHANGE_STEP 16
#define DEATHROES_LENGTH 256
#define BIG_BOOM_BOOM_COUNT 9
#define F_GRAVITY 1
#define SAUCER_ROTATION_RATE 8
#define SAUCER_CHANGE_RATE 16
#define CYCLES_PER_EXPLOSION_CHANGE 3
#define DELAY_LENGTH 15
#define GAME_OVER_FALL_ROW_HEIGHT 2
#define LETTER_WIDTH 33
#define LETTER_HEIGHT 33
#define SPACE_BETWEEN_HIGH_SCORE_LIST 8
#define HIGH_SCORE_COUNT 8
#define SCORE_OFFSET 28
#define COOL_ANIMATION false
#define ZERO_CHANGE_THRESHOLD 6
enum AIRCRAFT_IMAGE_TYPES
{
	PLAYER_IMAGE,
	PLAYER_DIVED,
	MISSILE_IMAGE,
	EXPLOSION_IMAGE,
	COMPUTER_STD_IMAGE,
	COMPUTER_HS_IMAGE,
	COMPUTER_MC_IMAGE,
	COMPUTER_HS_180,
	COMPUTER_MC_180
};
enum FORMATION_TYPES
{
	LEFT_ECHELON,
	RIGHT_ECHELON,
	ARROW,
	LINE
};
enum PATTERN_NAMES
{
	NO_TURN,           	//0
	LARGE_FIGURE_8,    	//1
	MEDIUM_FIGURE_8,   	//2
	SMALL_FIGURE_8,		//3
	X_FIGURE_8,		//4
	CIRCLE_OFF,		//5
	LARGE_SQUARE,		//6
	SMALL_SQUARE,		//7
	OCTAGONAL,		//8
	TO_AND_FRO,		//9
	TO_AND_FROWARD,		//10
	LARGE_SIN,		//11
	MEDIUM_SIN,		//12
	SMALL_SIN,		//13
	DEVIATE,               	//14          '''------......------'''
	LARGE_ZIG_ZAG,		//15
	MEDIUM_ZIG_ZAG,		//16
	SMALL_ZIG_ZAG,		//17
	SUPER_SMALL_ZIG_ZAG,	//18
	LARGE_CIRCLE,         	//19
	MEDIUM_CIRCLE,		//20
	SMALL_CIRCLE		//21
};
enum FRAME_TYPES
{
	STRAIGHT,
	RIGHT_BANK,
	LEFT_BANK

};
#define SAMPLE_COUNT 10
enum SOUNDS
{
	SHOOT,
	MUZAK,
	BOOM,
	DIVE_DOWN,
	DIVE_UP,
	MISSILE,
	SLO_ON,
	SLO_OFF,
	REPAIR,
	BOOM2
};
typedef struct _XYCOORD{int x; int y;} XYCOORD;
typedef struct _XYCOORD_f{fixed x; fixed y;} XYCOORD_f;


typedef struct _LINK{struct _LINK * next; int r;} LINK;

class FlightPattern
{
	private:
		LINK * linkon;	
		
	public:
		FlightPattern(int fpnum);
		~FlightPattern();
		LINK * Start();
};
